#!%SystemRoot%\system32\WindowsPowerShell\v1.0\powershell.exe # shebang:Windows PowerShell
# chcp 932 # 932:shift_jis
# [Environment]::NewLine = "`r`n"
Set-PSDebug -Strict

####  kintonedoc.ps1 ###################

# Auto-Variable -Name 'true'
# Auto-Variable -Name 'false'
# Auto-Variable -Name 'null'
# Auto-Variable -Name 'PSScriptRoot'
# Auto-Variable -Name 'PSItem'
# Auto-Variable -Name 'PID'

New-Variable -Name 'SYSExceptionCode' -Value $null;
New-Variable -Name 'SYSLogFilePath' -Value 'kintonedoc.log' -Scope 'Global';
New-Object -TypeName 'System.Collections.Hashtable' | Set-Variable -Name 'INIDATA' -Scope 'Global'
New-Object -TypeName 'System.Collections.Hashtable' | Set-Variable -Name 'PARAMDATA' -Scope 'Global'
New-Variable -Name 'OutLog' -Scope 'Global';
New-Variable -Name 'kindocwork' -Scope 'Global';

{
    Param(
         [System.String]$LogType
         ,[System.String]$Log
#        ,[Global]$global:SYSLogFilePath
    )

    Get-Date -Format 'yyyy/MM/dd HH:mm:ss' | Set-Variable -Name 'wkTime'
    [System.String]::Concat($wkTime, ' ', $LogType, ' ', $Log) |
      Out-File -FilePath $global:SYSLogFilePath -Encoding 'utf8' -Append

} | Set-Variable -Name 'OutLog'
{
    Param()
    New-Variable -Name 'SBExceptionCode' -Value $null;

    if($null -eq $SBExceptionCode){
        Join-Path -Path $PSScriptRoot -ChildPath 'Module\toastBox.psm1' | 
          Where-Object -FilterScript {Test-Path -Path $PSItem} |
            ForEach-Object -Process {
                Import-Module -Name $PSItem;
            }
          # End Pipe Where-Object
        # End Pipe $Join-Path
    }

    if($null -eq $SBExceptionCode){
        Join-Path -Path $PSScriptRoot -ChildPath 'kintonedoc.ini' |
          Where-Object -FilterScript {Test-Path -Path $PSItem} |
            ForEach-Object -Process {
                Import-Csv -Delimiter '=' -Path $PSItem -Header Key,Value -Encoding UTF8 |
                  Where-Object -FilterScript {$null -ne $PSItem} | Where-Object -FilterScript {($null -ne $PSItem.Key) -and ($null -ne $PSItem.Value)} | Where-Object -FilterScript {($PSItem.Key.Trim() -ne '') -and ($PSItem.Value.Trim() -ne '')} |
                    Where-Object -FilterScript {$global:INIDATA.ContainsKey($PSItem.Key.Trim()) -ne $true} |
                      ForEach-Object -Process {$global:INIDATA.Add($PSItem.Key.Trim(), $PSItem.Value.Trim())}
                    # End Pipe Where-Object
                  # End Pipe Where-Object
                # End Pipe Import-Csv
            }
          # End Pipe Where-Object
        # End Pipe Join-Path
    }

    if($null -eq $SBExceptionCode){
        'EndTime' | Set-Variable -Name 'wkKey'
        if($global:INIDATA.ContainsKey($wkKey)){
            Get-Date | Set-Variable -Name 'wkBegin', 'wkEnd'
            $global:PARAMDATA.Item('ResidentSpan') = 0;
            $wkBegin | Get-Date -Format 'yyyy/MM/dd HH:mm:ss' | ForEach-Object -Process {$global:PARAMDATA.Add('ResidentBeginTime', $PSItem)}
            $wkEnd | Get-Date -Format 'yyyy/MM/dd HH:mm:ss' | ForEach-Object -Process {$global:PARAMDATA.Add('ResidentEndTime', $PSItem)}
            if([System.DateTime]::TryParseExact($global:INIDATA.Item($wkKey), 'HH:mm:ss', [System.Globalization.DateTimeFormatInfo]::CurrentInfo, [System.Globalization.DateTimeStyles]::None,[ref] $wkEnd)){
                New-TimeSpan -Start $wkBegin -End $wkEnd | Set-Variable -Name 'wkSpan'
                if($wkSpan.TotalMilliseconds -ge $global:PARAMDATA.Item('ResidentSpan')){ # -ge >=
                    $global:PARAMDATA.Item('ResidentSpan') = $wkSpan.TotalMilliseconds;
                }
                Remove-Variable -Name 'wkSpan';
            }

            if($global:PARAMDATA.Item('ResidentSpan') -gt 0){ # -gt >
                if($global:PARAMDATA.Item('ResidentSpan') -le 15000){ # -le <=
                    $global:PARAMDATA.Item('ResidentSpan') = 15000;
                }
            } else {
                '101' | Set-Variable -Name 'SBExceptionCode'
            }
            Remove-Variable -Name 'wkBegin', 'wkEnd'
        }
    }
    if($null -eq $SBExceptionCode){
        'name' | Set-Variable -Name 'wkKey'
        if($global:INIDATA.ContainsKey($wkKey)){
            $global:PARAMDATA.Add('ResidentName', $global:INIDATA.Item($wkKey));
        } else {
#            '102' | Set-Variable -Name 'SBExceptionCode'
            $global:PARAMDATA.Add('ResidentName', 'kintonedoc');
        }
    }
    if($null -eq $SBExceptionCode){
        'path' | Set-Variable -Name 'wkKey'
        if($global:INIDATA.ContainsKey($wkKey)){
            $global:INIDATA.Item($wkKey) |
              Where-Object -FilterScript {Test-Path -Path $PSItem} |
                Where-Object -FilterScript {Get-Item -Path $PSItem | Where-Object -FilterScript {$PSItem.PSIsContainer}} |
                  ForEach-Object -Process {$global:PARAMDATA.Add('ResidentPath', $PSItem)}
                # End Pipe Where-Object
              # End Pipe Where-Object
            # End Pipe INIDATA.Item($wkKey)
        }

        if($global:PARAMDATA.ContainsKey('ResidentPath') -ne $true){
            '103' | Set-Variable -Name 'SBExceptionCode'
        }
    }
    if($null -eq $SBExceptionCode){
        'filter' | Set-Variable -Name 'wkKey'
        if($global:INIDATA.ContainsKey($wkKey)){
            $global:PARAMDATA.Add('ResidentFilter', $global:INIDATA.Item($wkKey));
        } else {
#            '104' | Set-Variable -Name 'SBExceptionCode'
            $global:PARAMDATA.Add('ResidentFilter', '*.*');
        }
    }
    if($null -eq $SBExceptionCode){
        'SubDirectories' | Set-Variable -Name 'wkKey'
        if($global:INIDATA.ContainsKey($wkKey)){
            if($global:INIDATA.Item($wkKey) -eq ''){
                $global:PARAMDATA.Add('ResidentSudBirectories', $true);
            }
        }
    }
    if($null -eq $SBExceptionCode){
        'toast' | Set-Variable -Name 'wkKey'
        if($global:INIDATA.ContainsKey($wkKey)){
            if($global:INIDATA.Item($wkKey) -eq ''){
                $global:PARAMDATA.Add('ResidentUseToast', 'USE');
            } else {
                $global:PARAMDATA.Add('ResidentUseToast', 'NONE');
            }
        }
    }
    if($null -eq $SBExceptionCode){
        $global:PARAMDATA.Add('ResidentPID', $PID.ToString());
        $global:PARAMDATA.Add('ResidentWait', '3000');
        $global:PARAMDATA.Add('ResidentListeners', 'Created|Changed|Renamed');
    }
    if($null -eq $SBExceptionCode){
        'SubDomain' | Set-Variable -Name 'wkKey'
        if($global:INIDATA.ContainsKey($wkKey)){
            $global:PARAMDATA.Add('KintoneSubDomain', $global:INIDATA.Item($wkKey));
        } else {
            '105' | Set-Variable -Name 'SBExceptionCode'
        }
    }
    if($null -eq $SBExceptionCode){
        'APIId' | Set-Variable -Name 'wkKey'
        if($global:INIDATA.ContainsKey($wkKey)){
            $global:PARAMDATA.Add('KintoneAPIId', $global:INIDATA.Item($wkKey));
        } else {
            '106' | Set-Variable -Name 'SBExceptionCode'
        }
    }
    if($null -eq $SBExceptionCode){
        'APIToken' | Set-Variable -Name 'wkKey'
        if($global:INIDATA.ContainsKey($wkKey)){
            $global:PARAMDATA.Add('KintoneAPIToken', $global:INIDATA.Item($wkKey));
        } else {
            '107' | Set-Variable -Name 'SBExceptionCode'
        }
    }
    if($null -eq $SBExceptionCode){
        'sys-license-code' | Set-Variable -Name 'wkKey'
        if($global:INIDATA.ContainsKey($wkKey)){
            New-Variable -Name 'wkLicKey'
            Try {
                $global:INIDATA.Item($wkKey) | Set-Variable -Name 'wkLicB64'
                [Text.Encoding]::Default.GetChars([System.Convert]::FromBase64String($wkLicB64)) | Set-Variable -Name 'wkLicArr'
                $wkLicArr -join '' | Set-Variable -Name 'wkLicKey'
            } Catch {
                '108' | Set-Variable -Name 'SBExceptionCode'
            } Finally {
                Remove-Variable -Name 'wkLicB64', 'wkLicArr'
            }

            New-Variable -Name 'wkLimitY';
            Get-ItemProperty -Path $PSCommandPath | Where-Object -FilterScript {$null -ne $PSItem.LastWriteTime} | ForEach-Object -Process {$PSItem.LastWriteTime | Set-Variable -Name 'wkLimitY'}
            Get-Date | Where-Object -FilterScript {$wkLimitY -isnot [System.DateTime]} | Set-Variable -Name 'wkLimitY'

            Get-Date | Set-Variable -Name 'wkBegin', 'wkLimit'
            if([System.DateTime]::TryParseExact($wkLicKey, 'ffffNMMdd HH:mm:ss:', [System.Globalization.DateTimeFormatInfo]::CurrentInfo, [System.Globalization.DateTimeStyles]::None,[ref] $wkLimit)){
                $wkLimit.AddYears($wkLimitY.Year - $wkLimit.Year + 0) | Set-Variable -Name 'wkLimit'
                if($wkBegin -le $wkLimit){ # -le <=
                    $global:PARAMDATA.Item('SysLicense') = $global:INIDATA.Item($wkKey);
                    $global:PARAMDATA.Item('SysLicenseNote') = $wkLimit.ToLongDateString();
                }
            }
            Remove-Variable -Name 'wkLicKey', 'wkLimitY', 'wkBegin', 'wkLimit'

        }
        '108' | Where-Object -FilterScript {$global:PARAMDATA.ContainsKey('SysLicense') -ne $true} | Set-Variable -Name 'SBExceptionCode'

    }

#    'wk*' | Get-Variable | Remove-Variable

    if($null -eq $SBExceptionCode){
        '0' | Set-Variable -Name 'SBExceptionCode'
    }
    Return $SBExceptionCode
    Remove-Variable -Name 'SBExceptionCode';
} | Set-Variable -Name 'wkSB'
if($null -eq $SYSExceptionCode){
    Try {
        Invoke-Command -ScriptBlock $wkSB | Where-Object -FilterScript {$PSItem -ne '0'} | Set-Variable -Name 'SYSExceptionCode'
        $global:PARAMDATA | Where-Object -FilterScript {$PSItem.ContainsKey('SysLicenseNote') -eq $true} | ForEach-Object -Process {Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[CZX]', $PSItem.Item('SysLicenseNote')} | Out-Null
    } Catch {
        '199' | Set-Variable -Name 'SYSExceptionCode'
    } Finally {
        Remove-Variable -Name 'wkSB'
    }
}
{
    Param(
        [System.String]$FilePath
#       ,[Global]$global:PARAMDATA
    )

    New-Variable -Name 'SBExceptionCode' -Value $null;
    {
        Param(
             [System.String]$FilePath
            ,[System.String]$TempPath
        )

        'SB2ExceptionCode*' | Get-Variable | Remove-Variable
        'SBwkContinue*' | Get-Variable | Remove-Variable
        'SBUTF8*' | Get-Variable | Remove-Variable
        'SBboundary*' | Get-Variable | Remove-Variable
        'SBCRLF*' | Get-Variable | Remove-Variable
        'SBStream*' | Get-Variable | Remove-Variable

        New-Variable -Name 'SB2ExceptionCode' -Value $null;
        New-Variable -Name 'SBUTF8' -Value $null;
        '----Boundary' | Set-Variable -Name 'SBboundary'
        "`r`n" | Set-Variable -Name 'SBCRLF'

        if($null -eq $SB2ExceptionCode){
            New-Variable -Name 'SBwkContinue';
            301 |
              Where-Object -FilterScript {Test-Path -Path $FilePath -PathType Leaf} |
                Where-Object -FilterScript {Test-Path -Path $TempPath | ForEach-Object -Process {$PSItem -ne $true}} |
                  Where-Object -FilterScript {$TempPath | ForEach-Object -Process {Split-Path -Path $PSItem -Parent} | Where-Object -FilterScript {Test-Path -Path $PSItem -PathType Container}} |
                    ForEach-Object -Process {'SBwkContinue*' | Get-Variable | Remove-Variable} |
                      Out-Null
            'SBwkContinue*' | Get-Variable | ForEach-Object -Process {301 | Set-Variable -Name 'SB2ExceptionCode'} | Remove-Variable
        }

        if($null -eq $SB2ExceptionCode){
            try {
                New-Object -TypeName 'System.Text.UTF8Encoding' -ArgumentList $false | Set-Variable -Name 'SBUTF8'
            } catch {
                302 | Set-Variable -Name 'SB2ExceptionCode'
            }
        }

        if($null -eq $SB2ExceptionCode){
            try {
                New-Object -TypeName 'System.IO.StreamWriter' -ArgumentList $TempPath, $false, $SBUTF8 | Set-Variable -Name 'SBStream'
                $SBStream.Write([System.String]::Concat('--', $SBboundary, $SBCRLF));
                Split-Path -Path $FilePath -Leaf | ForEach-Object -Process {[System.String]::Concat('Content-Disposition:', ' form-data','; name="file"', '; filename="', $PSItem, '"', $SBCRLF)} | ForEach-Object -Process {$SBStream.Write($PSItem);} | Out-Null
                $SBStream.Write([System.String]::Concat('Content-Type: application/octet-stream', $SBCRLF, $SBCRLF));
            } catch {
                303 | Set-Variable -Name 'SB2ExceptionCode'
            } finally {
                $SBStream.Close(); $SBStream.Dispose();
            }
        }

        if($null -eq $SB2ExceptionCode){
            New-Variable -Name 'SBBWriter' -Value $null;
                New-Object -TypeName 'System.IO.FileStream' -ArgumentList $TempPath, 6 | Set-Variable -Name 'SBStream'
                New-Object -TypeName 'System.IO.BinaryWriter' -ArgumentList $SBStream | Set-Variable -Name 'SBBWriter'

                $SBBWriter.Write([System.IO.File]::ReadAllBytes($FilePath))

            try {
            } catch {
                304 | Set-Variable -Name 'SB2ExceptionCode'
            } finally {
                if($null -ne $SBBWriter){
                    $SBBWriter.Close(); $SBBWriter.Dispose();
                }
                $SBStream.Close();  $SBStream.Dispose();
            }
        }

        if($null -eq $SB2ExceptionCode){
            try {
                New-Object -TypeName 'System.IO.StreamWriter' -ArgumentList $TempPath, $true, $SBUTF8 | Set-Variable -Name 'SBStream'
                $SBStream.Write([System.String]::Concat($SBCRLF));
                $SBStream.Write([System.String]::Concat('--', $SBboundary, '--', $SBCRLF));
            } catch {
                305 | Set-Variable -Name 'SB2ExceptionCode'
            } finally {
                $SBStream.Close();  $SBStream.Dispose();
            }
        }

        'SBMethod*' | Get-Variable | Remove-Variable
        if($null -eq $SB2ExceptionCode){
            0 | Set-Variable -Name 'SB2ExceptionCode'
        }
        Return $SB2ExceptionCode
        Remove-Variable -Name 'SB2ExceptionCode';

    } | Set-Variable -Name 'SBwkBoundarySB'

    {
        Param(
             [System.String]$SubDomain
            ,[System.String]$APIId
            ,[System.String]$APIToken
            ,[System.String]$FilePath
            ,[System.String]$WorkPath
        )
        New-Variable -Name 'SB3ExceptionCode' -Value $null;
        New-Variable -Name 'SBURLauthority' -Value $null; # <authority = scheme + userinfo + host + port>
        New-Variable -Name 'SBHeader' -Value $null;
        New-Variable -Name 'SBInFilePath' -Value $null;
        New-Variable -Name 'SBFileKey' -Value $null;
        New-Variable -Name 'SBRecId' -Value $null;

        if($null -eq $SB3ExceptionCode){
            $SubDomain |
              Where-Object -FilterScript {$PSItem -match '^[\w]+$'} |
                ForEach-Object -Process {[System.String]::Concat('https://', $PSItem, '.cybozu.com') | Set-Variable -Name 'SBURLauthority'}
            if($null -eq $SBURLauthority){
                401 | Set-Variable -Name 'SB3ExceptionCode'
            }
        }

        if($null -eq $SB3ExceptionCode){
            if($APIId -notmatch '^[\d]+$'){
                402 | Set-Variable -Name 'SB3ExceptionCode'
            }
        }

        if($null -eq $SB3ExceptionCode){
            $APIToken |
              Where-Object -FilterScript {$PSItem -match '^[\w]+$'} |
                ForEach-Object -Begin {New-Object -TypeName 'System.Collections.Hashtable' | Set-Variable -Name 'SBHeader'} -Process {$SBHeader.Add('X-Cybozu-API-Token', $PSItem)} |
                  Out-Null
            if($null -eq $SBHeader){
                403 | Set-Variable -Name 'SB3ExceptionCode'
            }
        }

        if($null -eq $SB3ExceptionCode){
            $FilePath |
              Where-Object -FilterScript {Test-Path -Path $PSItem -PathType Leaf} |
                Set-Variable -Name 'SBInFilePath'
            if($null -eq $SBInFilePath){
                404 | Set-Variable -Name 'SB3ExceptionCode'
            }
        }

        if($null -eq $SB3ExceptionCode){
            New-Variable -Name 'SBwkContinue';
            405 |
              Where-Object -FilterScript {Test-Path -Path $WorkPath | ForEach-Object -Process {$PSItem -ne $true}} |
                Where-Object -FilterScript {$WorkPath | ForEach-Object -Process {Split-Path -Path $PSItem -Parent} | Where-Object -FilterScript {Test-Path -Path $PSItem -PathType Container}} |
                  ForEach-Object -Process {'SBwkContinue*' | Get-Variable | Remove-Variable} |
                    Out-Null
            'SBwkContinue*' | Get-Variable | ForEach-Object -Process {405 | Set-Variable -Name 'SB3ExceptionCode'} | Remove-Variable

        }

        if($null -eq $SB3ExceptionCode){
            $SBHeader['Content-Type'] = 'multipart/form-data; boundary=----Boundary';
            [System.String]::Concat($SBURLauthority, '/k/v1/file.json') | Set-Variable -Name 'SBwkURL'

            try {
                Invoke-RestMethod -Method 'Post' -Uri $SBwkURL -Headers $SBHeader -InFile $SBInFilePath | 
                  Select-Object -Property 'fileKey' | 
                    ForEach-Object -Process {$PSItem.fileKey} | 
                      Set-Variable -Name 'SBFileKey'
            } catch {
                406 | Set-Variable -Name 'SB3ExceptionCode'
            } finally {
                'SBwkURL*' | Get-Variable | Remove-Variable
            }

            if($null -eq $SBFileKey){
                407 | Set-Variable -Name 'SB3ExceptionCode'
            }
        }

        if($null -eq $SB3ExceptionCode){
            $null | Set-Variable -Name 'SBInFilePath'

            New-Object -TypeName 'System.Collections.Hashtable' | Set-Variable -Name 'SBwkJsonObj'
            $SBwkJsonObj.Add('app', $APIId);
            New-Object -TypeName 'System.Collections.Hashtable' | ForEach-Object -Process {$SBwkJsonObj.Add('record', $PSItem)}
            New-Object -TypeName 'System.Collections.Hashtable' | ForEach-Object -Process {$SBwkJsonObj.record.Add('DOCGPCD', $PSItem);$SBwkJsonObj.record.DOCGPCD.Add('value', '0000');}
            New-Object -TypeName 'System.Collections.Hashtable' | ForEach-Object -Process {$SBwkJsonObj.record.Add('DOCGPNM', $PSItem);$SBwkJsonObj.record.DOCGPNM.Add('value', '̌');}
            New-Object -TypeName 'System.Collections.Hashtable' | Set-Variable -Name 'SBwkFilekeyItem'
            $SBwkFilekeyItem.Add('fileKey', $SBFileKey);
            New-Object -TypeName 'System.Collections.Hashtable' | ForEach-Object -Process {$SBwkJsonObj.record.Add('DOCFILE', $PSItem);$SBwkJsonObj.record.DOCFILE.Add('value', @($SBwkFilekeyItem));}
            'SBwkFilekeyItem*' | Get-Variable | Remove-Variable
            New-Object -TypeName 'System.Collections.Hashtable' | ForEach-Object -Process {$SBwkJsonObj.record.Add('DOCSAMMARY', $PSItem);$SBwkJsonObj.record.DOCSAMMARY.Add('value', '̌łł͂̋@\͂pł܂');}

            $SBwkJsonObj | ConvertTo-Json -Depth 32 | Out-File -FilePath $WorkPath -Encoding 'utf8'

            $WorkPath |
              Where-Object -FilterScript {Test-Path -Path $PSItem -PathType Leaf} |
                Set-Variable -Name 'SBInFilePath'
            if($null -eq $SBInFilePath){
                408 | Set-Variable -Name 'SB3ExceptionCode'
            }

            'SBwkJsonObj*' | Get-Variable | Remove-Variable
        }

        if($null -eq $SB3ExceptionCode){
            $SBHeader['Content-Type'] = 'application/json';
            [System.String]::Concat($SBURLauthority, '/k/v1/record.json') | Set-Variable -Name 'SBwkURL'
            $null | Set-Variable -Name 'SBwkResponse'

            try {
                Invoke-RestMethod -Method 'Post' -Uri $SBwkURL -Headers $SBHeader -InFile $SBInFilePath -ContentType 'application/json' | 
                  Set-Variable -Name 'SBwkResponse'
            } catch {
                409 | Set-Variable -Name 'SB3ExceptionCode'
            } finally {
                'SBwkURL*' | Get-Variable | Remove-Variable
            }

            if($null -eq $SBwkResponse){
                410 | Set-Variable -Name 'SB3ExceptionCode'
            }

            $SBwkResponse | 
              Select-Object -Property 'id' | 
                ForEach-Object -Process {$PSItem.id} | 
                      Set-Variable -Name 'SBRecId'

            if($SBRecId -notmatch '^[\d]+$'){
                411 | Set-Variable -Name 'SB3ExceptionCode'
            } else {
                [System.String]::Concat('VR[hԍF', $SBRecId) | ForEach-Object -Process {Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[ʒm]', $PSItem} | Out-Null
            }

            'SBwkResponse*' | Get-Variable | Remove-Variable
        }

        Remove-Variable -Name 'SBRecId';
        Remove-Variable -Name 'SBFileKey';
        Remove-Variable -Name 'SBInFilePath';
        Remove-Variable -Name 'SBHeader';
        Remove-Variable -Name 'SBURLauthority';
    #    Remove-Variable -Name 'SB3ExceptionCode';

        if($null -eq $SB3ExceptionCode){
            0 | Set-Variable -Name 'SB3ExceptionCode'
        }
        Return $SB3ExceptionCode
        Remove-Variable -Name 'SB3ExceptionCode';
    } | Set-Variable -Name 'SBwkNewRecSB'

    New-TemporaryFile | Set-Variable -Name 'SBBoundaryPath'
    New-TemporaryFile | Set-Variable -Name 'SBJsonPath'

    if($null -eq $SBExceptionCode){
        Try {
            $SBBoundaryPath.FullName | Where-Object -FilterScript {Test-Path -Path $PSItem -PathType Leaf} | ForEach-Object -Process {Remove-Item -Path $PSItem}
            Invoke-Command -ScriptBlock $SBwkBoundarySB -ArgumentList $FilePath, $SBBoundaryPath.FullName | Where-Object -FilterScript {$PSItem -ne '0'} | Set-Variable -Name 'SBExceptionCode'
        } Catch {
            '399' | Set-Variable -Name 'SBExceptionCode'
        } Finally {
            Remove-Variable -Name 'SBwkBoundarySB';
        }
    }

    if($null -eq $SBExceptionCode){
        Try {
            $SBJsonPath.FullName | Where-Object -FilterScript {Test-Path -Path $PSItem -PathType Leaf} | ForEach-Object -Process {Remove-Item -Path $PSItem}
            Invoke-Command -ScriptBlock $SBwkNewRecSB -ArgumentList $global:PARAMDATA.Item('KintoneSubDomain'), $global:PARAMDATA.Item('KintoneAPIId'), $global:PARAMDATA.Item('KintoneAPIToken'), $SBBoundaryPath.FullName, $SBJsonPath.FullName | Where-Object -FilterScript {$PSItem -ne '0'} | Set-Variable -Name 'SBExceptionCode'
        } Catch {
            '499' | Set-Variable -Name 'SBExceptionCode'
        } Finally {
            Remove-Variable -Name 'SBwkNewRecSB';
        }
    }

    if($null -ne $SBExceptionCode){
        if($global:INIDATA.ContainsKey($SBExceptionCode)){
            Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[G[]', $global:INIDATA.Item($SBExceptionCode) | Out-Null
        } else {
            Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[G[]', $SBExceptionCode | Out-Null
        }
    }

    $SBBoundaryPath.FullName | Where-Object -FilterScript {Test-Path -Path $PSItem -PathType Leaf} | ForEach-Object -Process {Remove-Item -Path $PSItem}
    $SBJsonPath.FullName | Where-Object -FilterScript {Test-Path -Path $PSItem -PathType Leaf} | ForEach-Object -Process {Remove-Item -Path $PSItem}
    if($null -eq $SBExceptionCode){
        $FilePath | Where-Object -FilterScript {Test-Path -Path $PSItem -PathType Leaf} | ForEach-Object -Process {Remove-Item -Path $PSItem}
    }

    Remove-Variable -Name 'SBBoundaryPath';
    Remove-Variable -Name 'SBJsonPath';

    if($null -eq $SBExceptionCode){
        '0' | Set-Variable -Name 'SBExceptionCode'
    }
    Return $SBExceptionCode
    Remove-Variable -Name 'SBExceptionCode';

} | Set-Variable -Name 'kindocwork'

{
    Param(
#        [Global]$global:PARAMDATA
#       ,[Global]$global:INIDATA
#       ,[Global]$global:OutLog
    )
    'sys-kintone-doc-begin' | Set-Variable -Name 'SBwkKey'
    if($global:INIDATA.ContainsKey($SBwkKey)){
        Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[ʒm]', $global:INIDATA.Item($SBwkKey) | Out-Null
    } else {
        Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[ʒm]', $SBwkKey | Out-Null
    }
    'SBwkKey*' | Get-Variable | Remove-Variable

    New-Variable -Name 'SBExceptionCode' -Value $null;
    'Begin' | Set-Variable -Name 'SBResidentState'
    New-Object -TypeName 'System.Management.Automation.PSObject' | Add-Member -MemberType 'ScriptMethod' -Name 'Dispose' -Value {} -PassThru | Set-Variable -Name 'SBobjTimer'
    New-Object -TypeName 'System.Collections.ArrayList' | Set-Variable -Name 'SBarrEvtId'

    if($SBResidentState -eq 'Begin'){
        Try {
            New-Object -TypeName 'Timers.Timer' -ArgumentList $global:PARAMDATA.Item('ResidentSpan') | Set-Variable -Name 'SBobjTimer'
        } Catch {
            $SBResidentState = 'Excp';
            $SBExceptionCode = '201';
        }
    }
    if($SBResidentState -eq 'Begin'){
        Try {
            New-Variable -Name 'wkStrId' -Value 'ResidentTimeOut';
            $SBobjTimer.AutoReset = $false;
            Register-ObjectEvent -InputObject $SBobjTimer -EventName 'Elapsed' -SourceIdentifier $wkStrId -Action {New-Event -SourceIdentifier 'resident.fin' | Out-Null;} | Out-Null;
            $SBobjTimer.Enabled = $true;
            $SBarrEvtId.Add($wkStrId) | Out-Null
        } Catch {
            $SBResidentState = 'Excp';
            $SBExceptionCode = '202';
        } Finally {
            Remove-Variable -Name 'wkStrId';
        }
    }

    if($SBResidentState -eq 'Begin'){
        New-Variable -Name 'SBwkFSEvSb';
        New-Variable -Name wkFSEvArr -Value @{};
        $wkFSEvArr['Created'] = 'CreateEv';
        $wkFSEvArr['Changed'] = 'ChangeEv';
        $wkFSEvArr['Deleted'] = 'DeleteEv';
        $wkFSEvArr['Renamed'] = 'RenameEv';

        {
#            # Automatic_Variables
#            Param(
#                [System.Management.Automation.PSEventArgs]$Event
#               ,[System.EventArgs]$EventArgs
#               ,[System.Management.Automation.PSEventSubscriber]$EventSubscriber
#               ,[System.Object]$Sender
#               ,[System.Object[]]$Args
#
#               ,[Global]$global:INIDATA
#               ,[Global]$global:OutLog
#               ,[Global]$global:kindocwork
#               )

            New-Variable -Name 'SB2wkFilePath' -Value $Event.SourceEventArgs.FullPath;
            New-Variable -Name wkChangeType -Value $Event.SourceEventArgs.ChangeType;
            New-Variable -Name wkMillisec -Value $Event.MessageData.WaitMillisec;
            New-Variable -Name wkToast -Value $Event.MessageData.Toast;
            New-Variable -Name wkExePath -Value $Event.MessageData.Path1Exe;
            New-Variable -Name wkScriptPath -Value $Event.MessageData.Path2Script;
            New-Variable -Name wkConfigPath -Value $Event.MessageData.Path3Conf;
            New-Variable -Name wkRaiseEventName -Value $Event.MessageData.RaiseEventName;
            New-Variable -Name wkWaiterObj;
            New-Variable -Name wkWaiterEvNm;
            New-Variable -Name wkArgStr;
            New-Variable -Name wkWaitEvSb;
            New-Variable -Name wkWaitEvMessage;

            'sys-catch-file-event' | Set-Variable -Name 'SBwkKey'
            if($global:INIDATA.ContainsKey($SBwkKey)){
                [System.String]::Concat($global:INIDATA.Item($SBwkKey), '(', $wkChangeType, ')') | Set-Variable -Name 'SBwkInfo'
                Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[ʒm]', $SBwkInfo | Out-Null
                'SBwkInfo*' | Get-Variable | Remove-Variable
            } else {
                Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[ʒm]', $SBwkKey | Out-Null
            }
            'SBwkKey*' | Get-Variable | Remove-Variable

            if([System.Int32]::TryParse($wkMillisec, [System.Management.Automation.PSReference]$null) -eq $true){
                $wkMillisec = [System.Int32]$wkMillisec;
                $wkWaiterEvNm = 'WAIT' + $SB2wkFilePath;
            } else {
                $wkMillisec = 0;
                $wkWaiterEvNm = '';
            }

            if($wkMillisec -gt 0){ # -gt >
                Try {
                    Get-Job | Where-Object {$PSItem.Name -eq $wkWaiterEvNm} | Remove-Job -Force
                } Catch {
                    $wkMillisec = -1;
                }
            }
            if($wkMillisec -gt 0){ # -gt >
                $wkWaitEvSb = {
#                    # Automatic_Variables
#                    Param(
#                        [System.Management.Automation.PSEventArgs]$Event
#                       ,[System.EventArgs]$EventArgs
#                       ,[System.Management.Automation.PSEventSubscriber]$EventSubscriber
#                       ,[System.Object]$Sender
#                       ,[System.Object[]]$Args
#
#                       ,[Global]$global:INIDATA
#                       ,[Global]$global:OutLog
#                       ,[Global]$global:kindocwork
#                       )
                    New-Variable -Name wkToast -Value $Event.MessageData.Toast;
                    New-Variable -Name wkExePath -Value $Event.MessageData.Path1Exe;
                    New-Variable -Name wkScriptPath -Value $Event.MessageData.Path2Script;
                    New-Variable -Name wkConfigPath -Value $Event.MessageData.Path3Conf;
                    New-Variable -Name 'SB3wkFilePath' -Value $Event.MessageData.Path4Data;
                    New-Variable -Name wkArgStr;

                    'sys-file-event-waiting' | Set-Variable -Name 'SBwkKey'
                    if($global:INIDATA.ContainsKey($SBwkKey)){
                        Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[ʒm]', $global:INIDATA.Item($SBwkKey) | Out-Null
                    } else {
                        Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[ʒm]', $SBwkKey | Out-Null
                    }
                    'SBwkKey*' | Get-Variable | Remove-Variable

                    if($wkToast -eq 'USE'){
                        $wkArgStr = "$(Get-Date), Waited, $SB3wkFilePath";
                        toastBox($wkArgStr) | Out-Null;
                    }

#                    $wkArgStr = "-f  $strPathStr";
                    $wkArgStr = "-f ""$wkScriptPath"" ""$wkConfigPath"" ""$SB3wkFilePath""";
#                    Start-Process -FilePath $wkExePath -ArgumentList $wkArgStr -WindowStyle Minimized;
                    Invoke-Command -ScriptBlock $global:kindocwork -ArgumentList $SB3wkFilePath | Out-Null

                    Remove-Variable -Name 'SB3wkFilePath';
                    Remove-Variable -Name wkMillisec;
                    Remove-Variable -Name wkToast;
                    Remove-Variable -Name wkExePath;
                    Remove-Variable -Name wkScriptPath;
                    Remove-Variable -Name wkConfigPath;
                    Remove-Variable -Name wkArgStr;
                };
                $wkWaitEvMessage = New-Object -TypeName PSObject;
                $wkWaitEvMessage | Add-Member -MemberType NoteProperty -Name Toast -Value $wkToast;
                $wkWaitEvMessage | Add-Member -MemberType NoteProperty -Name Path1Exe -Value $wkExePath;
                $wkWaitEvMessage | Add-Member -MemberType NoteProperty -Name Path2Script -Value $wkScriptPath;
                $wkWaitEvMessage | Add-Member -MemberType NoteProperty -Name Path3Conf -Value $wkConfigPath;
                $wkWaitEvMessage | Add-Member -MemberType NoteProperty -Name Path4Data -Value $SB2wkFilePath;

                Try {
                    $wkWaiterObj = New-Object Timers.Timer($wkMillisec);
                    $wkWaiterObj.AutoReset = $false;
                    Register-ObjectEvent -InputObject $wkWaiterObj -EventName 'Elapsed' -SourceIdentifier $wkWaiterEvNm -Action $wkWaitEvSb -MessageData $wkWaitEvMessage | Out-Null;
                    $wkWaiterObj.Enabled = $true;
#                    $SBarrEvtId.Add($wkWaiterEvNm) | Out-Null
                } Catch {
                    $wkWaiterObj.Dispose() | Out-Null;
                    Remove-Variable -Name wkWaiterObj;
                    $wkMillisec = 0;
                }
            }
            if($wkMillisec -eq 0){
                if($wkToast -eq 'USE'){
                    $wkArgStr = "$(Get-Date), $wkChangeType, $SB2wkFilePath";
                    toastBox($wkArgStr) | Out-Null
                }

                if($wkRaiseEventName -eq ''){
#                    $wkArgStr = "-f  $strPathStr";
                    $wkArgStr = "-f ""$wkScriptPath"" ""$wkConfigPath"" ""$SB2wkFilePath""";
#                    Start-Process -FilePath $wkExePath -ArgumentList $wkArgStr -WindowStyle Minimized;
                    Invoke-Command -ScriptBlock $global:kindocwork -ArgumentList $SB2wkFilePath | Out-Null
                } else {
                    New-Event -SourceIdentifier $wkRaiseEventName | Out-Null;
                }
            }
            if($wkMillisec -lt 0){ # -lt <
                # none
            }

            Remove-Variable -Name 'SB2wkFilePath';
            Remove-Variable -Name wkChangeType;
            Remove-Variable -Name wkMillisec;
            Remove-Variable -Name wkToast;
            Remove-Variable -Name wkExePath;
            Remove-Variable -Name wkScriptPath;
            Remove-Variable -Name wkConfigPath;
            Remove-Variable -Name wkRaiseEventName;
#            Remove-Variable -Name wkWaiterObj;
            Remove-Variable -Name wkWaiterEvNm;
            Remove-Variable -Name wkArgStr;
#            Remove-Variable -Name wkWaitEvSb;
            Remove-Variable -Name wkWaitEvMessage;

        } | Set-Variable -Name 'SBwkFSEvSb'

        New-Variable -Name 'SBwkResidKey';
#        New-Variable -Name wk1FSWatch;
#        New-Variable -Name wk1FSEvMessage;

            Get-Date -Format 'yyyyMMddHHmmss' | Set-Variable -Name 'SBwkResidKey'
            Try {
                $wk1FSWatch = New-Object System.IO.FileSystemWatcher;
                $wk1FSEvMessage = New-Object -TypeName PSObject;
                $wk1FSEvMessage | Add-Member -MemberType NoteProperty -Name WaitMillisec -Value $global:PARAMDATA.Item('ResidentWait');
                $wk1FSEvMessage | Add-Member -MemberType NoteProperty -Name Toast -Value $global:PARAMDATA.Item('ResidentUseToast');
                $wk1FSEvMessage | Add-Member -MemberType NoteProperty -Name Path1Exe -Value '';
                $wk1FSEvMessage | Add-Member -MemberType NoteProperty -Name Path2Script -Value '';
                $wk1FSEvMessage | Add-Member -MemberType NoteProperty -Name Path3Conf -Value 'Trial';
                $wk1FSEvMessage | Add-Member -MemberType NoteProperty -Name RaiseEventName -Value '';

                $wk1FSWatch.BeginInit();
                $wk1FSWatch.Path = $global:PARAMDATA.Item('ResidentPath');
                $wk1FSWatch.Filter = $global:PARAMDATA.Item('ResidentFilter');
                $wk1FSWatch.IncludeSubdirectories = $global:PARAMDATA.ContainsKey('ResidentSubDirectories');

#                New-Variable -Name 'SBwk2Key';
                New-Variable -Name 'SBwk2EventSubScrId';
                foreach($SBwk2Key in $wkFSEvArr.Keys){
                    if($global:PARAMDATA.Item('ResidentListeners').IndexOf($SBwk2Key) -ne -1){
                        $SBwk2EventSubScrId = $global:PARAMDATA.Item('ResidentPID') + $SBwkResidKey + $wkFSEvArr[$SBwk2Key];
                        Register-ObjectEvent -InputObject $wk1FSWatch -EventName $SBwk2Key -SourceIdentifier $SBwk2EventSubScrId -Action $SBwkFSEvSb -MessageData $wk1FSEvMessage | Out-Null;
                        $SBarrEvtId.Add($SBwk2EventSubScrId) | Out-Null
                    }
                }

                $SBwk2EventSubScrId = $global:PARAMDATA.Item('ResidentPID') + $SBwkResidKey + 'Error';
                Register-ObjectEvent -InputObject $wk1FSWatch -EventName 'Error' -SourceIdentifier $SBwk2EventSubScrId -Action {New-Event -SourceIdentifier 'resident.error';} | Out-Null;
                $SBarrEvtId.Add($SBwk2EventSubScrId) | Out-Null

#                Remove-Variable -Name 'SBwk2Key';
                Remove-Variable -Name 'SBwk2EventSubScrId';

                $wk1FSWatch.EnableRaisingEvents = $true;

                $wk1FSWatch.EndInit();

            } Catch {
                $SBResidentState = 'Excp';
                $SBExceptionCode = '204';
            } Finally {
            }
#        Remove-Variable -Name 'SBwkFSEvSb';
        Remove-Variable -Name wkFSEvArr;
        Remove-Variable -Name 'SBwkResidKey';
#        Remove-Variable -Name wk1FSWatch;
#        Remove-Variable -Name wk1FSEvMessage;
    }

    switch($SBResidentState){
    'Begin' {
        'sys-kintone-doc-start' | Set-Variable -Name 'SBwkKey'
        if($global:INIDATA.ContainsKey($SBwkKey)){
            Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[ʒm]', $global:INIDATA.Item($SBwkKey) | Out-Null
            Try {
                Write-Host $global:INIDATA.Item($SBwkKey);
                toastBox($global:PARAMDATA.Item('ResidentName'), $global:INIDATA.Item($SBwkKey)) | Out-Null;
            } Catch {
            } Finally {
            }
        } else {
            Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[ʒm]', $SBwkKey | Out-Null
            Try {
                Write-Host $SBwkKey;
                toastBox($global:PARAMDATA.Item('ResidentName'), $SBwkKey) | Out-Null;
            } Catch {
            } Finally {
            }
        }
        'SBwkKey*' | Get-Variable | Remove-Variable
        $SBResidentState = 'Resident';
        continue;}

    'End' {continue;}

    Default {
        if($global:INIDATA.ContainsKey($SBExceptionCode)){
            Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[G[]', $global:INIDATA.Item($SBExceptionCode) | Out-Null
            Try {
                Write-Host $global:INIDATA.Item($SBExceptionCode);
                toastBox($global:PARAMDATA.Item('ResidentName'), $global:INIDATA.Item($SBExceptionCode)) | Out-Null;
            } Catch {
            } Finally {
            }
        } else {
            Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[sȃG[]', $SBExceptionCode | Out-Null
            Try {
                Write-Host '[sȃG[]';
                toastBox($global:PARAMDATA.Item('ResidentName'), '[sȃG[]') | Out-Null;
            } Catch {
            } Finally {
            }
        }
        $SBResidentState = 'End';
        continue;}
    }

    Try {
        if($SBResidentState -eq 'Resident'){
            New-Variable -Name flgLoop -Value $true;
            New-Variable -Name wk1PSEventArgs;
            while ($flgLoop){
                $wk1PSEventArgs = Wait-Event;
                if($wk1PSEventArgs.SourceIdentifier -eq 'resident.fin'){
                    $SBResidentState = 'TimeOut';
                    $SBExceptionCode = '0';
                    $flgLoop = $false;
                } elseif($wk1PSEventArgs.SourceIdentifier -eq 'resident.error'){
                    $SBResidentState = 'Error';
                    $SBExceptionCode = '298';
                    $flgLoop = $false;
                } else {
#                    $flgLoop = $flgLoop;
                }
                $wk1PSEventArgs | Remove-Event;
            }
            Remove-Variable -Name flgLoop;
            Remove-Variable -Name wk1PSEventArgs;
        }
    } Catch {
        $SBResidentState = 'CatchedException';
        $SBExceptionCode = '299';
    } Finally {
        $SBarrEvtId | ForEach-Object { Remove-Job -Name $PSItem -Force};

        New-Variable -Name 'SBOutToast' -Value '';
        New-Variable -Name 'SBOutHost' -Value '';
        New-Variable -Name 'SBLogType' -Value '';
        New-Variable -Name 'SBOutLogFile' -Value '';
        New-Variable -Name 'SBMessage' -Value '';
        if($SBResidentState -eq 'TimeOut'){
            'sys-kintone-doc-timeout-end' | Set-Variable -Name 'SBwkKey'
            if($global:INIDATA.ContainsKey($SBwkKey)){
                $SBMessage = $global:INIDATA.Item($SBwkKey);
            } else {
                $SBMessage = $SBwkKey;
            }
            'SBwkKey*' | Get-Variable | Remove-Variable
            $SBOutToast = $SBMessage;
            $SBOutHost = $SBMessage;
            $SBLogType = '[ʒm]';
            $SBOutLogFile = $SBMessage;
            $SBResidentState = 'End';
        } elseif($SBResidentState -eq 'Error'){
            'sys-kintone-doc-exception-end' | Set-Variable -Name 'SBwkKey'
            if($global:INIDATA.ContainsKey($SBwkKey)){
                $SBMessage = $global:INIDATA.Item($SBwkKey);
            } else {
                $SBMessage = $SBwkKey;
            }
            'SBwkKey*' | Get-Variable | Remove-Variable
            $SBOutToast = $SBMessage;
            $SBOutHost = $SBMessage;
            $SBLogType = '[G[]';
            $SBOutLogFile = $SBMessage;
            $SBResidentState = 'End';
        } elseif($SBResidentState -eq 'CatchedException'){
            'sys-kintone-doc-exception-end' | Set-Variable -Name 'SBwkKey'
            if($global:INIDATA.ContainsKey($SBwkKey)){
                $SBMessage = $global:INIDATA.Item($SBwkKey);
            } else {
                $SBMessage = $SBwkKey;
            }
            'SBwkKey*' | Get-Variable | Remove-Variable
            $SBOutToast = $SBMessage;
            $SBOutHost = $SBMessage;
            $SBLogType = '[G[]';
            $SBOutLogFile = $SBMessage;
            $SBResidentState = 'End';
        } elseif($SBResidentState -eq 'End'){
            # none
        } else {
            'sys-kintone-doc-signal-end' | Set-Variable -Name 'SBwkKey'
            if($global:INIDATA.ContainsKey($SBwkKey)){
                $SBMessage = $global:INIDATA.Item($SBwkKey);
            } else {
                $SBMessage = $SBwkKey;
            }
            'SBwkKey*' | Get-Variable | Remove-Variable
            $SBOutToast = $SBMessage;
            $SBOutHost = $SBMessage;
            $SBLogType = '[ʒm]';
            $SBOutLogFile = $SBMessage;
            $SBResidentState = 'End';
        }

        if($SBOutToast -ne ''){
            Try {
                toastBox($global:PARAMDATA.Item('ResidentName'), $SBOutToast) | Out-Null;
            } Catch {
            } Finally {
            }
        }
        if($SBOutHost -ne ''){
            Write-Host $SBOutHost;
        }
        if($SBOutLogFile -ne ''){
            Invoke-Command -ScriptBlock $global:OutLog -ArgumentList $SBLogType, $SBOutLogFile | Out-Null
        }

        Remove-Variable -Name 'SBMessage';
        Remove-Variable -Name 'SBLogType';
        Remove-Variable -Name 'SBOutHost';
        Remove-Variable -Name 'SBOutLogFile';
        Remove-Variable -Name 'SBOutToast';
        $SBobjTimer.Dispose();
        Remove-Variable -Name 'SBobjTimer';
        Remove-Variable -Name 'SBarrEvtId';
        Remove-Variable -Name 'SBResidentState';

        if($SBExceptionCode -eq '299'){
            exit $SBExceptionCode;
        }
    }

    'sys-kintone-doc-fin' | Set-Variable -Name 'SBwkKey'
    if($global:INIDATA.ContainsKey($SBwkKey)){
        Write-Host $global:INIDATA.Item($SBwkKey);
    } else {
        $SBMessage = $SBwkKey;
    }
    'SBwkKey*' | Get-Variable | Remove-Variable

    return [int]$SBExceptionCode;
#    Remove-Variable -Name SBExceptionCode;
} | Set-Variable -Name 'wkSB'
if($null -eq $SYSExceptionCode){
    Try {
        Invoke-Command -ScriptBlock $wkSB | Where-Object -FilterScript {$PSItem -ne '0'} | Set-Variable -Name 'SYSExceptionCode'
    } Catch {
        '299' | Set-Variable -Name 'SYSExceptionCode'
    } Finally {
        Remove-Variable -Name 'wkSB'
    }
}

if($null -eq $SYSExceptionCode){
    if($global:INIDATA.ContainsKey($SYSExceptionCode)){
        Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[G[]', $global:INIDATA.Item($SYSExceptionCode) | Out-Null
    } else {
        Invoke-Command -ScriptBlock $global:OutLog -ArgumentList '[sȃG[]', $SYSExceptionCode | Out-Null
    }
}

Remove-Variable -Name 'kindocwork';
Remove-Variable -Name 'OutLog';
Remove-Variable -Name 'PARAMDATA';
Remove-Variable -Name 'INIDATA';
Remove-Variable -Name 'SYSLogFilePath';

exit [int]$SYSExceptionCode;
Remove-Variable -Name 'SYSExceptionCode';
